import _regeneratorRuntime from 'babel-runtime/regenerator';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

var _dec, _class, _class2, _temp2;

import { Component, Children } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';

var DEFAULT_LOCALE = 'en';
var mapStateToProps = function mapStateToProps(_ref) {
  var locale = _ref.locale;
  return { locale: locale };
};

var LocaleProvider = (_dec = connect(mapStateToProps), _dec(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(LocaleProvider, _Component);

  function LocaleProvider() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, LocaleProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = LocaleProvider.__proto__ || _Object$getPrototypeOf(LocaleProvider)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      currentLocale: undefined,
      currentLocaleData: undefined
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(LocaleProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _state = this.state,
          currentLocale = _state.currentLocale,
          currentLocaleData = _state.currentLocaleData;

      return {
        i18n: {
          locale: currentLocale,
          localeData: currentLocaleData
        }
      };
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.updateLocaleData(this.props, this.state);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextState) {
      this.updateLocaleData(nextProps, nextState);
    }
  }, {
    key: 'getLocaleFromProps',
    value: function getLocaleFromProps(props) {
      var localeData = props.localeData,
          locale = props.locale;

      return localeData[locale] ? locale : DEFAULT_LOCALE;
    }
  }, {
    key: 'updateLocaleData',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(props, state) {
        var localeData, locale, currentLocaleData;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                localeData = props.localeData;
                locale = this.getLocaleFromProps(props);

                if (!(locale !== state.currentLocale)) {
                  _context.next = 12;
                  break;
                }

                currentLocaleData = localeData[locale];

                if (!(typeof currentLocaleData !== 'function')) {
                  _context.next = 8;
                  break;
                }

                this.setState({
                  currentLocale: locale,
                  currentLocaleData: currentLocaleData
                });
                _context.next = 12;
                break;

              case 8:
                _context.next = 10;
                return currentLocaleData();

              case 10:
                currentLocaleData = _context.sent;

                if (this.getLocaleFromProps(this.props) === locale) {
                  this.setState({
                    currentLocale: locale,
                    currentLocaleData: currentLocaleData
                  });
                }

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateLocaleData(_x, _x2) {
        return _ref3.apply(this, arguments);
      }

      return updateLocaleData;
    }()
  }, {
    key: 'render',
    value: function render() {
      var currentLocale = this.state.currentLocale;


      if (!currentLocale) {
        return null;
      }

      return Children.only(this.props.children);
    }
  }]);

  return LocaleProvider;
}(Component), _class2.propTypes = {
  locale: PropTypes.string.isRequired, // eslint-disable-line
  children: PropTypes.any.isRequired,
  localeData: PropTypes.object // eslint-disable-line
}, _class2.defaultProps = {
  localeData: {}
}, _class2.childContextTypes = {
  i18n: PropTypes.object.isRequired
}, _temp2)) || _class);
export { LocaleProvider as default };