import _extends from 'babel-runtime/helpers/extends';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import { Component, createElement } from 'react';
import PropTypes from 'prop-types';
import isArray from 'lodash/isArray';
import memoize from 'lodash/memoize';

var memoizedPluralForm = memoize(function (locale, localeData) {
  var messages = localeData.messages;


  if (messages) {
    // eslint-disable-next-line
    return Function('n', 'nplurals', 'plural', messages[''].plural_forms + ' return plural;');
  }

  return function (n) {
    return n === 1 ? 0 : 1;
  };
});

export var propTypes = {
  locale: PropTypes.string,
  gettext: PropTypes.func,
  ngettext: PropTypes.func,
  pgettext: PropTypes.func,
  npgettext: PropTypes.func,
  i18n: PropTypes.object,
  localizedRef: PropTypes.func
};

export default (function (WrappedComponent) {
  var _class, _temp2, _initialiseProps;

  return _temp2 = _class = function (_Component) {
    _inherits(LocalizedComponent, _Component);

    function LocalizedComponent() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, LocalizedComponent);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = LocalizedComponent.__proto__ || _Object$getPrototypeOf(LocalizedComponent)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(LocalizedComponent, [{
      key: 'getPluralForm',
      value: function getPluralForm(n) {
        var locale = this.getLocale();
        var localeData = this.getLocaleData();
        return memoizedPluralForm(locale, localeData)(n);
      }
    }, {
      key: 'getMessage',
      value: function getMessage(message, context) {
        var _getLocaleData = this.getLocaleData(),
            messages = _getLocaleData.messages;

        if (messages) {
          var messageId = context ? context + '\x04' + message : message;
          return messages[messageId] || null;
        }

        return null;
      }
    }, {
      key: 'getLocale',
      value: function getLocale() {
        var locale = this.context.i18n.locale;

        return locale;
      }
    }, {
      key: 'getLocaleData',
      value: function getLocaleData() {
        var localeData = this.context.i18n.localeData;

        return localeData || {};
      }
    }, {
      key: 'replaceInjections',
      value: function replaceInjections(input, injections) {
        return input.replace(/{([0-9])}/g, function (match, index) {
          return injections[index];
        });
      }
    }, {
      key: 'render',
      value: function render() {
        var localizedRef = this.props.localizedRef;

        var locale = this.getLocale();
        var localeData = this.getLocaleData();
        return createElement(WrappedComponent, _extends({}, this.props, {
          locale: locale,
          gettext: this.gettext,
          ngettext: this.ngettext,
          pgettext: this.pgettext,
          npgettext: this.npgettext,
          i18n: localeData.additions,
          ref: localizedRef
        }));
      }
    }]);

    return LocalizedComponent;
  }(Component), _class.propTypes = {
    localizedRef: PropTypes.func
  }, _class.contextTypes = {
    i18n: PropTypes.object.isRequired
  }, _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.gettext = function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _this2.pgettext.apply(_this2, [undefined].concat(args));
    };

    this.pgettext = function (context, input) {
      for (var _len3 = arguments.length, injections = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
        injections[_key3 - 2] = arguments[_key3];
      }

      var message = _this2.getMessage(input, context);
      var output = void 0;

      if (message) {
        output = isArray(message) ? message[0] : message;
      } else {
        output = input;
      }

      return _this2.replaceInjections(output, injections);
    };

    this.ngettext = function () {
      for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return _this2.npgettext.apply(_this2, [undefined].concat(args));
    };

    this.npgettext = function (context, singular, plural, n) {
      for (var _len5 = arguments.length, injections = Array(_len5 > 4 ? _len5 - 4 : 0), _key5 = 4; _key5 < _len5; _key5++) {
        injections[_key5 - 4] = arguments[_key5];
      }

      var message = _this2.getMessage(singular, context);
      var output = void 0;

      if (message) {
        output = message[_this2.getPluralForm(n)];
      } else {
        output = [singular, plural][_this2.getPluralForm(n)];
      }

      return _this2.replaceInjections(output, injections);
    };
  }, _temp2;
});